#include <iostream>
#include <cmath>

using namespace std;

int main()
{
    int N,M,i,j,C;
    cin >>N >>M;
    int A[N],B[M];
    for(i=1;i<=M;i++)
    {
        cin >>B[i];
    }
    cin >>C;
    for(i=1;i<=N;i++)
    {
        A[i] = i;
    }
    for(i=0; i<=(N-M); i++)
    {
        for (j=1; j<=M; j++)
        {
            A[i+B[j]] = A[i+j];
        }
    }
    double x=0;
    for(i=1;i<=N;i++)
    {
        x = x + (pow(C,i) * A[i]);
    }
    if(0<=x && x<998244353)
    {
        cout <<x;
    }
}